--
-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-- THIS FILE IS AUTOMATICALLY GENERATED BY THE sqlplayer.py
-- DO NOT EDIT AS IT WILL GET OVERWRITTEN
-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
--


-- Executing 01_drop.sql

DROP DATABASE IF EXISTS northwind_dwh;

-- Executing 02_create_db.sql

CREATE DATABASE northwind_dwh;

-- Executing 10_staging_customer.sql

USE `northwind_dwh`;

CREATE TABLE `staging_customer` (
    id INT NOT NULL,
    company varchar(50) NOT NULL,
    state_province varchar(50) NOT NULL,
    city varchar(50) NOT NULL,
    
    PRIMARY KEY(id)
);


-- Executing 10_staging_employee.sql

USE `northwind_dwh`;

CREATE TABLE `staging_employee` (
    id INT NOT NULL,
    last_name varchar(50) NOT NULL,
    first_name varchar(50) NOT NULL,
    email_address varchar(50) NOT NULL,

    PRIMARY KEY(id)
) ENGINE=InnoDB AUTO_INCREMENT=1000;


-- Executing 10_staging_order_details.sql

USE `northwind_dwh`;

CREATE TABLE `staging_order_details` (
    id INT NOT NULL,
    
    discount DOUBLE NOT NULL DEFAULT 0,
    order_id INT NOT NULL,
    product_id INT NOT NULL,
    quantity INT NOT NULL,
    unit_price DECIMAL(19,4) NOT NULL,

    PRIMARY KEY(id)
);


-- Executing 10_staging_orders.sql

USE `northwind_dwh`;

CREATE TABLE `staging_orders` (
    id INT NOT NULL,
    
    order_date DATETIME NOT NULL,
    shipped_date DATETIME,
    paid_date DATETIME,
    employee_id INT NOT NULL,
    customer_id INT NOT NULL,

    PRIMARY KEY(id)
);


-- Executing 10_staging_product.sql

USE `northwind_dwh`;

CREATE TABLE `staging_product` (
    id INT NOT NULL,
    category varchar(50) NOT NULL,
    product_name varchar(50) NOT NULL,
    standard_cost DECIMAL(19,4) NOT NULL,
    PRIMARY KEY(id)
);


-- Executing 20_integrated_sales.sql

USE `northwind_dwh`;

CREATE TABLE `integrated_sales` (
    order_id INT NOT NULL,
    order_details_id INT NOT NULL,

    order_date DATETIME,
    shipped_date DATETIME,
    paid_date DATETIME,
    employee_id INT NOT NULL,
    customer_id INT NOT NULL,
    product_id INT NOT NULL,

    unit_price DECIMAL(19,4) NOT NULL,
    quantity INT NOT NULL,
    discount DOUBLE NOT NULL DEFAULT 0,

    PRIMARY KEY(order_id, order_details_id)
);


-- Executing 30_clean_product.sql

USE `northwind_dwh`;

CREATE TABLE `clean_product` (
    id INT NOT NULL,
    category varchar(50) NOT NULL,
    product_name varchar(50) NOT NULL,
    standard_cost DECIMAL(19,4) NOT NULL,
    PRIMARY KEY(id)
);


-- Executing 30_clean_sales.sql

USE `northwind_dwh`;

CREATE TABLE `clean_sales` (
    order_id INT NOT NULL,
    order_details_id INT NOT NULL,

    order_date DATETIME,
    shipped_date DATETIME,
    paid_date DATETIME,
    employee_id INT NOT NULL,
    customer_id INT NOT NULL,
    product_id INT NOT NULL,

    unit_price DECIMAL(19,4) NOT NULL,
    quantity INT NOT NULL,
    discount DOUBLE NOT NULL DEFAULT 0,

    PRIMARY KEY(order_id, order_details_id)
);


-- Executing 31_enriched_employee.sql

USE `northwind_dwh`;

CREATE TABLE `enriched_employee` (
    id INT NOT NULL,
    full_name varchar(100),
    email_address varchar(50),

    PRIMARY KEY(id)
);


-- Executing 31_enriched_sales.sql

USE `northwind_dwh`;

CREATE TABLE `enriched_sales` (
    order_id INT NOT NULL,
    order_details_id INT NOT NULL,

    order_date DATE NOT NULL,
    shipped_date DATE NOT NULL,
    paid_date DATE NOT NULL,
    employee_id INT NOT NULL,
    customer_id INT NOT NULL,
    product_id INT NOT NULL,

    unit_price DECIMAL(19,4) NOT NULL,
    quantity INT NOT NULL,
    discount DOUBLE NOT NULL DEFAULT 0,
    revenue DECIMAL(19, 4) NOT NULL,    -- a calculated value: (unit_price * quantity) * (1.0 - discount/100)

    PRIMARY KEY(order_id, order_details_id)
);


-- Executing 40_dim_customer.sql

USE `northwind_dwh`;

CREATE TABLE `dim_customer` (
    id INT NOT NULL,
    version INT NOT NULL,
    date_from DATETIME,
    date_to DATETIME,

    customer_id INT,
    company varchar(50),
    state_province varchar(50),
    city varchar(50),
    PRIMARY KEY(id)
);

CREATE INDEX idx_dim_customer_lookup ON dim_customer(customer_id);


-- Executing 40_dim_date.sql

-- This SQL script creates a 'date dimension' table and fills it with data.
-- It does so by using a 'stored procedure', which is also created as part
-- of this script. IOW, this script does:
--   - Create a `dim_date` table
--   - Create a stored procedure to "generate date data"
--   - Calls the stored procedure for a specific date range (e.g. 1.1.2005 to 31.12.2007)

-- from http://tech.akom.net/archives/36-Creating-A-Basic-Date-Dimension-Table-in-MySQL.html

USE `northwind_dwh`;

CREATE TABLE dim_date  (
    id INT NOT NULL auto_increment,
    fulldate date,
    dayofmonth int,
    dayofyear int,
    dayofweek int,
    dayname varchar(10),
    monthnumber int,
    monthname varchar(10),
    year    int,
    quarter tinyint,
    PRIMARY KEY(id)
) ENGINE=InnoDB AUTO_INCREMENT=1000;

-- To avoid issues e.g. on Windows' MySQL Workbench, complaining update violating 
-- 'safe updates' while populating the 'date dimension'
SET SQL_SAFE_UPDATES = 0;

DELIMITER $$

CREATE PROCEDURE datetimeinsert (v_full_date DATE)
BEGIN

    INSERT INTO dim_date (
        fulldate ,
        dayofmonth ,
        dayofyear ,
        dayofweek ,
        dayname ,
        monthnumber,
        monthname,
        year,
        quarter
    ) VALUES (
        v_full_date,
        DAYOFMONTH(v_full_date),
        DAYOFYEAR(v_full_date),
        DAYOFWEEK(v_full_date),
        DAYNAME(v_full_date),
        MONTH(v_full_date),
        MONTHNAME(v_full_date),
        YEAR(v_full_date),
        QUARTER(v_full_date)
    );

END$$

CREATE PROCEDURE datedimbuild (p_start_date DATE, p_end_date DATE)
BEGIN
    DECLARE v_full_date DATE;

    DELETE FROM dim_date;

    SET v_full_date = p_start_date;
    WHILE v_full_date < p_end_date DO
        call datetimeinsert(v_full_date);
        SET v_full_date = DATE_ADD(v_full_date, INTERVAL 1 DAY);
    END WHILE;

    -- moreover, create a 'dummy date' entry to denote 'yet unknown'. This is used e.g.
    -- by orders' shipping_date and paid_date, which may not be knwon at the time of
    -- date extraction
    call datetimeinsert(DATE('9999-12-31'));

END$$

DELIMITER ;

call datedimbuild('2005-01-01', '2007-12-31');


-- Executing 40_dim_employee.sql

USE `northwind_dwh`;

CREATE TABLE `dim_employee` (
    id INT NOT NULL,
    version INT NOT NULL,
    date_from DATETIME,
    date_to DATETIME,

    employee_id INT,
    full_name varchar(100),
    email_address varchar(50),

    PRIMARY KEY(id)
);

CREATE INDEX idx_dim_employee_lookup ON dim_employee(employee_id);

-- Executing 40_dim_product.sql

USE `northwind_dwh`;

CREATE TABLE `dim_product` (
    id INT NOT NULL,
    version INT NOT NULL,
    date_from DATETIME,
    date_to DATETIME,

    product_id INT,
    category varchar(50),
    product_name varchar(50),
    standard_cost DECIMAL(19,4),

    PRIMARY KEY(id)
);

CREATE INDEX idx_dim_product_lookup ON dim_product(product_id);


-- Executing 41_fact_sales.sql

USE `northwind_dwh`;

CREATE TABLE `fact_sales` (
    order_date_id INT NOT NULL,
    shipped_date_id INT NOT NULL,
    paid_date_id INT NOT NULL,

    customer_id INT NOT NULL,
    employee_id INT NOT NULL,
    product_id INT NOT NULL,

    unit_price DECIMAL(19, 4) NOT NULL,
    quantity INT NOT NULL,
    revenue DECIMAL(19, 4) NOT NULL,
    discount DOUBLE NOT NULL DEFAULT 0,

    FOREIGN KEY fk_date(order_date_id) REFERENCES dim_date(id),
    FOREIGN KEY fk_shipped_date(shipped_date_id) REFERENCES dim_date(id),
    FOREIGN KEY fk_paid_date(paid_date_id) REFERENCES dim_date(id),
    FOREIGN KEY fk_customer(customer_id) REFERENCES dim_customer(id),
    FOREIGN KEY fk_employee(employee_id) REFERENCES dim_employee(id),
    FOREIGN KEY fk_product(product_id) REFERENCES dim_product(id),

    PRIMARY KEY(order_date_id, shipped_date_id, paid_date_id, customer_id, employee_id, product_id)
);
